import java.io.*;
import java.util.*;

public class BypassMigration{

    
//     public static void PrintRandomGraphOutput(){
// 	RGraph rg = Rgraph.getNewRandomMGraph(10,10);
// 	SGraph sg = new SGraph(rg);

// 	System.out.print(sg);
//     }
    //RGNtoBNMapper rgnTobn = bg.getRGNtoBNMapper();

    public static void doScheduling(RGraph rg, StatRec sr){
	int numBypass = rg.getFreeBypassNodes().size();
	int maxBypassUsed = 0;
	int maxStartDegree = rg.computeMaxDegree();
	int numSteps=0;
	while(rg.maxDegree()>0){
	    int currMaxDeg = rg.maxDegree();
	    numSteps++;
	    //Debug.trace(rg);
	    BGraph bg = new BGraph(rg);
	    //Debug.trace(bg);	    
	    Matching match = new Matching(bg);
	    //Debug.trace(match);

	    Stack stRGNFreeBypass = rg.getFreeBypassNodes();
	    int numFreeBypassNodes = stRGNFreeBypass.size();
	    //Debug.trace(numFreeBypassNodes);
	    
	    int numBypassUsed = numBypass - numFreeBypassNodes;
	    maxBypassUsed = MyMath.max(maxBypassUsed, numBypassUsed);

	    RGraph rgPathsAndCycles = Matching.getPathsAndCycles(match);

	    //Debug.trace("rgPathsAndCycles");
	    //Debug.trace(rgPathsAndCycles);
	    int maxDegree = rgPathsAndCycles.computeMaxDegree();
	    Assert.PRE(maxDegree<=2);

	    RGNode arrMaxNodes[] = RGraph.getMaxNodes(rg.getNodes(),
						      rgPathsAndCycles.getNodes(),
						      rg.computeMaxDegree());

	    //Debug.trace("arrMaxNodes");
	    //Debug.trace(arrMaxNodes);
	    
	    PhaseSchedule ps = new PhaseSchedule(rg.numNodes(),
						 arrMaxNodes,
						 stRGNFreeBypass);
	    //Debug.trace(ps);
	    RGEdge addEdges[] = ps.getAddEdges();
	    RGEdge removeEdges[] = ps.getRemoveEdges();

	    //Debug.trace(addEdges);
	    //Debug.trace(removeEdges);

	    //Debug.trace2(addEdges,removeEdges);
	    rg.updateEdges(addEdges,removeEdges);
	    Assert.POST(rg.computeMaxDegree()==currMaxDeg-1);
	    //Debug.trace(rg);
	}
	//Debug.trace2(maxStartDegree,numSteps);
	//Debug.trace("maxBypassUsed");
	//Debug.trace(maxBypassUsed);
	sr.addData(maxStartDegree,maxBypassUsed);
    }


    //PRE: arrSArgs contains 3 integers i1,i2,i3
    //POST: creates and runs Bypass Migration on i3 random graphs with i1 nodes and i2 edges
    public static void main(String[] arrSArgs){
	Assert.PRE(arrSArgs.length==5);
	String s1 = arrSArgs[0];
	String s2 = arrSArgs[1];
	String s3 = arrSArgs[2];
	String s4 = arrSArgs[3];
	String s5 = arrSArgs[4];

	int numNodes = Integer.parseInt(s1);
	int startDensity = Integer.parseInt(s2);
	int endDensity = Integer.parseInt(s3);
	int densityStep = Integer.parseInt(s4);
	int numTrials = Integer.parseInt(s5);

	Random rSource = new Random(107);

	for(int currDensity=startDensity;currDensity<=endDensity;currDensity+=densityStep){
	    StatRec sr = new StatRec();
	    for(int i=0;i<numTrials;i++){
		int numEdges = numNodes*currDensity;
		RGraph rg = new RGraph(numNodes,numEdges,rSource);
		doScheduling(rg,sr);
		Debug.trace(i);
		Debug.trace(sr);
	    }
	    Debug.trace("currDensity: ");
	    Debug.trace(currDensity);

	    Debug.trace(sr);
	}
    }
};
