import java.io.*;
import java.util.*;
public class Cycle{

    public Cycle(RGNode firstNode, RGEdge arrRGE[]){
	this.arrRGE = arrRGE;
	this.firstNode = firstNode;
	Assert.PRE(arrRGE.length>=2);

	RGEdge rgeFirst = arrRGE[0];
	int numEdges = arrRGE.length;
	RGEdge rgeLast = arrRGE[numEdges-1];

	Assert.POST(numEdges>=2);
	Assert.POST(rgeFirst.contains(firstNode));
	Assert.POST(rgeLast.contains(firstNode));
    }
    
    public boolean isEven(){
	return (arrRGE.length%2==0);
    }

    public RGEdge[] getEdges(){
	return arrRGE;
    }


    //PRE: this is an odd cycle of length >=3.

    //POST: RES is all the edges to send in this.
    public RGEdge[] getEdgesToSend(){
	Assert.PRE(!isEven());
	Assert.PRE(arrRGE.length>=3);
	int numEdges = arrRGE.length;

	int numRemEdges = numEdges/2;
	RGEdge arrRemoveEdges[] = new RGEdge[numRemEdges];

	RGEdge bypassedEdge = arrRGE[0];
	RGNode rgnSenderToBypass = bypassedEdge.source();

	//arrRemoveEdges[0] = bypassedEdge;
	if(rgnSenderToBypass==firstNode){
	    int edgeIndex = 1;
	    for(int i=0;i<numRemEdges;i++){
		arrRemoveEdges[i] = arrRGE[edgeIndex];
		edgeIndex+=2;
	    }
	}else{
	    int edgeIndex = 2;
	    for(int i=0;i<numRemEdges;i++){
		arrRemoveEdges[i] = arrRGE[edgeIndex];
		edgeIndex+=2;
	    }
	}
	return arrRemoveEdges;
    }

    //PRE: this is an odd cycle 
    public RGEdge getBypassedEdge(){
	Assert.PRE(!isEven());
	return arrRGE[0];
    }

    public String toString(){
	return MyIOUtils.arrToString(arrRGE,"\n");
    }

    RGEdge arrRGE[];
    RGNode firstNode;
};
