import java.io.*;
import java.util.*;


public class MyMath
{

//PRE: low<high
//POST: returns a random integer greater than or equal to low and less
//than high
public static int randomNumber(int low, int high)
    {
	Random rSource = new Random();
	return randomNumber(low,high,rSource);
    }

public static int randomNumber(int low, int high, Random rSource)
    {
	int range = high - low;
	Assert.PRE(range>0);
	
	int rand = rSource.nextInt();
	rand = absoluteValue(rand);
	rand = rand % range;

	rand = rand + low;
	Assert.INRANGE(rand,low,high);
	return rand;
    }


    //POST: returns a number in the >=low and <high which is not equal to n1
public static int diffRandomNumber(int low, int high, int n1, Random rSource)
    {
	int rand=n1;
	while(rand==n1){
	    rand = randomNumber(low,high,rSource);
	}	
	return rand;
    }


    public static int absoluteValue(int i){
	return (i<0) ? -i : i;
    }

    public static int max(int x, int y){
	return (x>y) ? x : y;
    }

	//POST: RES 
public static void randomlyShuffleArray(Object arrIn[])
    {
	int size = arrIn.length;
	
	for(int i=0;i<size;i++){
	    int rand = randomNumber(i,size-1);
	    arrIn[i] = arrIn[rand];
	}
    }
}
    

    
