import java.io.*;
import java.util.*;

public class RGEdge{
    public RGEdge(RGNode source, RGNode sink){
	this.source = source;
	this.sink = sink;
    }

    public RGEdge(Edge e){
	RGNode rgnSource = e.source().rgnode();
	RGNode rgnSink = e.sink().rgnode();

	int idSource = rgnSource.getUniqueNumber();
	int idSink = rgnSink.getUniqueNumber();
	this.source =  new RGNode(idSource);
	this.sink = new RGNode(idSink);
    }

    public boolean contains(RGNode rgn){
	return (source==rgn||sink==rgn);
    }

    public RGNode source(){
	return source;
    }

    public RGNode sink(){
	return sink;
    }
    
    public RGNode getNeighbor(RGNode n){
	if(n==source){
	    return sink;
	}
	else{
	    Assert.PRE(n==sink);
	    return source;
	}
    }

    public boolean equal(RGEdge rge){
	return (rge.source==source && rge.sink==sink);
    }

    public String toString(){
	int id1 = source.getUniqueNumber();
	int id2 = sink.getUniqueNumber();
	String sRes = "Edge:" + Integer.toString(id1) + " " + Integer.toString(id2);

	return sRes;
    }


    public static RGEdge []vectorToarrEdge(Vector v){
	int vSize = v.size();
	RGEdge[] arrRGE = new RGEdge[vSize];
	for(int i=0;i<vSize;i++){
	    RGEdge rge = (RGEdge) v.elementAt(i);
	    arrRGE[i] = rge;
	}
	return arrRGE;
    }




    RGNode source;
    RGNode sink;
};
