//maps rgraph nodes to bigraph nodes

import java.io.*;
import java.util.*;
public class RGNtoBNMapper{

    public RGNtoBNMapper(int numRgraphNodes){
	arrRGNtoLeftNodes = new Node[numRgraphNodes];
	arrRGNtoRightNodes = new Node[numRgraphNodes];
    }

    public void insertLeft(int rgnNum, Node n){
	arrRGNtoLeftNodes[rgnNum] = n;
    }
    
    public void insertRight(int rgnNum, Node n){
	arrRGNtoRightNodes[rgnNum] = n;
    }

    //POST: RES is null if there is no node on the left side containin
    //rgn otherwise, RES equals that node
    public Node getLeftNodeFromRGN(RGNode rgn){
	int rgnNum = rgn.getUniqueNumber();
	Node n = arrRGNtoLeftNodes[rgnNum];
	return n;
    }

    //PRE: rgn is a RGNode which is contained on the right side of the graph
    //POST: RES equals the node that contains rgn on the right side
    public Node getRightNodeFromRGN(RGNode rgn){
	int rgnNum = rgn.getUniqueNumber();
	Node n = arrRGNtoRightNodes[rgnNum];
	Assert.POST(n!=null);
	return n;
    }

    public int numRGNodes(){
	return arrRGNtoLeftNodes.length;
    }

    Node arrRGNtoLeftNodes[];
    Node arrRGNtoRightNodes[];
};
